<?php namespace EwTools\Twig;

use Twig_Environment;
use Twig_Error_Runtime;
use Twig_Source;
use Twig_SourceContextLoaderInterface;

/**
 * Environment
 *
 * @link    http://infomaker.se
 * @package EwTools\Twig
 * @since   EwTools\Twig\Environment 0.1
 */
class Environment extends Twig_Environment {
    
    /**
     * Loads a specific template and compiles it. If cache is on, save the compiled class in cac3he to be evaluated
     * later on.
     *
     * @param string   $name
     * @param int|null $index
     *
     * @throws Twig_Error_Runtime
     * @since 0.1
     * @return \Twig_TemplateInterface
     */
    public function loadTemplate( $name, $index = null ) {
        $cls = $mainCls = $this->getTemplateClass( $name );
        
        if( isset( $this->loadedTemplates[ $cls ] ) ) {
            return $this->loadedTemplates[ $cls ];
        }
        
        if( ! class_exists( $cls, false ) ) {
            if( $this->cache instanceof objectCacheSystem ) {
                // Fetch template from cache and load
                $this->cache->load( $this->cache->generateKey( $name, $mainCls ) );
            }
        }
        
        return parent::loadTemplate( $name, $index );
    }
}